#pragma once

#include "opensbi/opensbi.h"

namespace drivers {
namespace opensbi::pmu {

    SbiRet num_counters();

    SbiRet counter_get_info(unsigned long counter_idx);

    SbiRet counter_config_matching(
            unsigned long counter_idx_base,
            unsigned long counter_idx_mask,
            unsigned long config_flags,
            unsigned long event_idx,
            uint64_t event_data);

    SbiRet counter_start(
            unsigned long counter_idx_base,
            unsigned long counter_idx_mask,
            unsigned long start_flags,
            uint64_t initial_value);

    SbiRet counter_stop(
            unsigned long counter_idx_base,
            unsigned long counter_idx_mask,
            unsigned long stop_flags);

    SbiRet counter_fw_read(unsigned long counter_idx);

}  // End namespace opensbi::pmu
}  // End namespace drivers
