#pragma once

#include "opensbi/opensbi.h"

namespace drivers {
namespace opensbi::rfence {

    SbiRet remote_fence_i(HartMask hart_mask);

    SbiRet remote_sfence_vma(
            HartMask hart_mask,
            unsigned long start_addr,
            unsigned long size);

    SbiRet remote_sfence_vma_asid(
            HartMask hart_mask,
            unsigned long start_addr,
            unsigned long size,
            unsigned long asid);

    SbiRet remote_hfence_gvma_vmid(
            HartMask hart_mask,
            unsigned long start_addr,
            unsigned long size,
            unsigned long vmid);

    SbiRet remote_hfence_gvma(
            HartMask hart_mask,
            unsigned long start_addr,
            unsigned long size);

    SbiRet remote_hfence_vvma_asid(
            HartMask hart_mask,
            unsigned long start_addr,
            unsigned long size,
            unsigned long asid);

    SbiRet remote_hfence_vvma(
            HartMask hart_mask,
            unsigned long start_addr,
            unsigned long size);

}  // End namespace opensbi::rfence
}  // End namespace drivers
